# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.2.2.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::ServerManagement
  module Models
    #
    # Parameter collection for creation and other operations on sessions.
    #
    class SessionParameters

      include MsRestAzure

      include MsRest::JSONable
      # @return [String] Encrypted User name to be used to connect to node.
      attr_accessor :user_name

      # @return [String] Encrypted Password associated with user name.
      attr_accessor :password

      # @return [RetentionPeriod] Session retention period. Possible values
      # include: 'Session', 'Persistent'
      attr_accessor :retention_period

      # @return [CredentialDataFormat] Credential data format. Possible values
      # include: 'RsaEncrypted'
      attr_accessor :credential_data_format

      # @return [String] Encryption certificate thumbprint.
      attr_accessor :encryption_certificate_thumbprint


      #
      # Mapper for SessionParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'SessionParameters',
          type: {
            name: 'Composite',
            class_name: 'SessionParameters',
            model_properties: {
              user_name: {
                required: false,
                serialized_name: 'properties.userName',
                type: {
                  name: 'String'
                }
              },
              password: {
                required: false,
                serialized_name: 'properties.password',
                type: {
                  name: 'String'
                }
              },
              retention_period: {
                required: false,
                serialized_name: 'properties.retentionPeriod',
                type: {
                  name: 'Enum',
                  module: 'RetentionPeriod'
                }
              },
              credential_data_format: {
                required: false,
                serialized_name: 'properties.credentialDataFormat',
                type: {
                  name: 'Enum',
                  module: 'CredentialDataFormat'
                }
              },
              encryption_certificate_thumbprint: {
                required: false,
                serialized_name: 'properties.EncryptionCertificateThumbprint',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
